﻿var isLibExpired = true;

//Set start date manually
var startDate = new Date();

//Set expiry date manually
var expiryDate = new Date();

/**
 * Checks the validity of Library
 * If library is expired, APIs cannot be used
 * Start and expiry dates are manually set
 * */
function initLib(){
	setDate(startDate, 2012, 4, 1, 0, 0, 0);
	setDate(expiryDate, 2012, 5, 30, 23, 59, 59)
	
	var sysDate = new Date();
	if (sysDate == expiryDate){
		console.log("Today is SmartWemo's expiry date");	
	}
	
	if (startDate <= sysDate && sysDate <= expiryDate){
		isLibExpired = false;
	} else {
		isLibExpired = true;
		alert("Sorry, the library you are using has expired..")
	}
	console.log("Library is expired? " + isLibExpired);	
}

/** 
 * Sets the date
 * date Date object
 * yy year
 * mm month
 * dd day
 * hh hour
 * min minutes
 * ss seconds
 * 
 * */
function setDate(date, yy, mm, dd, hh, min, ss) {
	date.setFullYear(yy, mm, dd);
	date.setHours(hh);
	date.setMinutes(min);
	date.setSeconds(ss);	
} 

if (typeof Acceleration === "undefined") {
	Acceleration = function(aX, aY, aZ) {
		this.aX = aX;
		this.aY = aY;
		this.aZ = aZ;
		this.aTimestamp = new Date().getTime();
	}
};

if (typeof Accelerometer === "undefined") {
	Accelerometer = {};
	Accelerometer.success = {};
	Accelerometer.startListener = function(successCallback, errorCallback, params) {
		if ( isLibExpired == true ) {
			console.log("Cannot use Accelerometer#startListener because Library has expired...");
			return;
		}
		
        if (typeof successCallback != "function") 
        {
            console.log("Accelerometer Error: successCallback is not a function");
            return;
        }
        
        Accelerometer.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Accelerometer Error: errorCallback is not a function");
            return;
        }
        
		if (!params.samplingRate) 
		{
		    console.log(" Error: samplingRate is undefined!");
			if (errorCallback && (typeof errorCallback == "function")) 
				errorCallback("Accelerometer Error: firstName is undefined!");
		    return;
		}        
		
		if (params.samplingRate < 0 || params.samplingRate > 60) 
		{
		    console.log(" Error: samplingRate value should be from 1-60!");
			if (errorCallback && (typeof errorCallback == "function")) 
				errorCallback(" Error: samplingRate value should be from 1-60!");
		    return;
		}  
        
		var accel = HybridLib.startAccelerometer(params.samplingRate);
		var obj = $.parseJSON(accel);

		if(obj.success == false && typeof errorCallback === "function")
			errorCallback(obj.text);
	}
	
	Accelerometer.stopListener = function(successCallback, errorCallback, params) {
		if ( isLibExpired == true ) {
			console.log("Cannot use Accelerometer#stopListener because Library has expired...");
			return;
		}		
		
        if (typeof successCallback != "function") 
        {
            console.log("Accelerometer Error: successCallback is not a function");
            return;
        }
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Accelerometer Error: errorCallback is not a function");
            return;
        }
		
		var accel = HybridLib.stopAccelerometer();
		var obj = $.parseJSON(accel);
		
		if(obj.success == true){
			successCallback();
			Accelerometer.success  = {};
		}else if(typeof errorCallback == "function")
			errorCallback(obj.text);		
	}
	
	Accelerometer.update = function(json) {
		if ( isLibExpired == true ) {
			console.log("Cannot use Accelerometer#update because Library has expired...");
			return;
		}	
		
		obj = $.parseJSON(json);
		//alert(json);
		if (typeof successCallback != "function") 
			Accelerometer.success(new Acceleration(obj.X, obj.Y, obj.Z));
	}
	
	Acceleration.MAX_X = 1.0;
	Acceleration.MIN_X = -1.0;
	Acceleration.MAX_Y = 1.0;
	Acceleration.MIN_Y = -1.0;
	Acceleration.MAX_Z = 1.0;
	Acceleration.MIN_Z = -1.0;	
};

if(typeof AudioSettings === "undefined"){
	AudioSettings  = {
		isVibrate : function(successCallback, errorCallback)
		{
			if ( isLibExpired == true ) {
				console.log("Cannot use AudioSettings#isVibrate because Library has expired...");
				return;
			}	
		
	        if (successCallback && (typeof successCallback != "function"))
	        {
	            console.log("Audio Setting Error: successCallback is not a function");
	            return;
	        }
	        if (errorCallback && (typeof errorCallback != "function")) 
	        {
	            console.log("Audio Setting Error: errorCallback is not a function");
	            return;
	        }
			var isVibrate = HybridLib.isVibrate();
			if (isVibrate == 0)
			{
				successCallback(false);
			} 
			else if (isVibrate == 1)
			{
				successCallback(true);
			}
			else {
				errorCallback("Vibrate State Retreival Fail");
			}
		},
		enableVibrate : function(successCallback, errorCallback){
			if ( isLibExpired == true ) {
				console.log("Cannot use AudioSettings#enableVibrate because Library has expired...");
				return;
			}	
			
			if (successCallback && (typeof successCallback != "function"))
	        {
	            console.log("Audio Setting Error: successCallback is not a function");
	            return;
	        }
	        if (errorCallback && (typeof errorCallback != "function")) 
	        {
	            console.log("Audio Setting Error: errorCallback is not a function");
	            return;
	        }
			var enableVibrate = HybridLib.enableVibrate();
			if (enableVibrate == 0)
			{
				successCallback(true);
			} else {
				errorCallback("Vibrate enable error");
			}
		},
		disableVibrate : function(successCallback, errorCallback){
			if ( isLibExpired == true ) {
				console.log("Cannot use AudioSettings#disableVibrate because Library has expired...");
				return;
			}	
			
			if (successCallback && (typeof successCallback != "function"))
	        {
	            console.log("Audio Setting Error: successCallback is not a function");
	            return;
	        }
	        if (errorCallback && (typeof errorCallback != "function")) 
	        {
	            console.log("Audio Setting Error: errorCallback is not a function");
	            return;
	        }
			var disableVibrate = HybridLib.disableVibrate();
			if (disableVibrate == 0)
			{
				successCallback();
			} else {
				errorCallback("Vibrate Disable Fail");
			}
		},
		setRingtone : function(successCallback, errorCallback){
			if ( isLibExpired == true ) {
				console.log("Cannot use AudioSettings#setRingtone because Library has expired...");
				return;
			}	
			
			if (successCallback && (typeof successCallback != "function"))
	        {
	            console.log("Audio Setting Error: successCallback is not a function");
	            return;
	        }
	        if (errorCallback && (typeof errorCallback != "function")) 
	        {
	            console.log("Audio Setting Error: errorCallback is not a function");
	            return;
	        }
			HybridLib.setRingTone();
		},
		getRingtoneVolume : function(successCallback, errorCallback){
			if ( isLibExpired == true ) {
				console.log("Cannot use AudioSettings#getRingtoneVolume because Library has expired...");
				return;
			}	
			
			if (successCallback && (typeof successCallback != "function"))
	        {
	            console.log("Audio Setting Error: successCallback is not a function");
	            return;
	        }
	        if (errorCallback && (typeof errorCallback != "function")) 
	        {
	            console.log("Audio Setting Error: errorCallback is not a function");
	            return;
	        }
			var ringVol = HybridLib.getRingtoneVol();
			if (ringVol >= 0)
			{
				successCallback(ringVol);
			} else {
				errorCallback();
			}
		},
		getMediaVolume : function(successCallback, errorCallback){
			if ( isLibExpired == true ) {
				console.log("Cannot use AudioSettings#getMediaVolume because Library has expired...");
				return;
			}	
			
			if (successCallback && (typeof successCallback != "function"))
	        {
	            console.log("Audio Setting Error: successCallback is not a function");
	            return;
	        }
	        if (errorCallback && (typeof errorCallback != "function")) 
	        {
	            console.log("Audio Setting Error: errorCallback is not a function");
	            return;
	        }
			var mediaVol = HybridLib.getMediaVol();
			if (mediaVol >= 0)
			{
				successCallback(mediaVol);
			} else {
				errorCallback();
			}
		},
		setRingtoneVolume : function(successCallback, errorCallback, params){
			if ( isLibExpired == true ) {
				console.log("Cannot use AudioSettings#setRingtoneVolume because Library has expired...");
				return;
			}	
			
			if (successCallback && (typeof successCallback != "function"))
	        {
	            console.log("Audio Setting Error: successCallback is not a function");
	            return;
	        }
	        if (errorCallback && (typeof errorCallback != "function")) 
	        {
	            console.log("Audio Setting Error: errorCallback is not a function");
	            return;
	        }
			var res = HybridLib.setRingtoneVol(params.toRaise);
			if (res == 0)
			{
				successCallback();
			} else {
				errorCallback();
			}
		},
		setMediaVolume : function(successCallback, errorCallback, params){
			if ( isLibExpired == true ) {
				console.log("Cannot use AudioSettings#setMediaVolume because Library has expired...");
				return;
			}	
			
			if (successCallback && (typeof successCallback != "function"))
	        {
	            console.log("Audio Setting Error: successCallback is not a function");
	            return;
	        }
	        if (errorCallback && (typeof errorCallback != "function")) 
	        {
	            console.log("Audio Setting Error: errorCallback is not a function");
	            return;
	        }
			var res = HybridLib.setMediaVol(params.toRaise);
			if (res == 0)
			{
				successCallback();
			} else {
				errorCallback();
			}
		},
	};
};

if (typeof Camera === "undefined") {
	Camera = {

	}

	Camera.imageSource = {
		CAMERA : 0,
		GALLERY : 1
	}

	Camera.imageType = {
		JPEG : 0,
		PNG : 1
	}

	Camera.jpegQuality = {
		SFINE : 100,
		FINE : 70,
		NORMAL : 50
	}

	// Initialize camera parameters with default values.
	function CameraParams() {
		this.source = Camera.imageSource.CAMERA,
				this.type = Camera.imageType.JPEG,
				this.quality = Camera.jpegQuality.NORMAL
	}
	Camera.callbacks = {};

	Camera.captureImage = function(successCallback, errorCallback, params) {
		if ( isLibExpired == true ) {
			console.log("Cannot use Camera#captureImage because Library has expired...");
			return;
		}			

		if (typeof params === "undefined") {
			params = new CameraParams();
		}

		// successCallback optional
        if (successCallback && (typeof successCallback != "function"))
        {
            console.log("Camera Error: successCallback is not a function");
            return;
        }
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Camera Error: errorCallback is not a function");
            return;
        }		
		
		if (typeof successCallback === "function") {
			Camera.callbacks = {
				success : successCallback,
				error : errorCallback
			};
		}
		var strParam = JSON.stringify(params);
		HybridLib.launchCamera();
	}

	Camera.onSuccess = function(strImage) {
		if (typeof Camera.callbacks.success === "function") {
			Camera.callbacks.success(strImage);
		}
	}
	Camera.onError = function() {
		if (typeof Camera.callbacks.error === "function") {
			Camera.callbacks.error("Camera image capture failed!");
		}
	}
};

if (typeof Connectivity === "undefined") {
	Connectivity = {
		getInternetSource: function(successCallback, errorCallback, params){
		
			if ( isLibExpired == true ) {
				console.log("Cannot use Connectivity#getInternetSource because Library has expired...");
				return;
			}
		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("Connectivity Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("Connectivity Error: errorCallback is not a function");
                return;
            }
            					
    		var json = HybridLib.getSource();
    		var obj = $.parseJSON(''+json);

    		if(obj.success != false)
    		{
    			successCallback(obj.type);
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}  
		},
		hasInternet: function(successCallback, errorCallback, params){
			if ( isLibExpired == true ) {
				console.log("Cannot use Connectivity#hasInternet because Library has expired...");
				return;
			}
			
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("Connectivity Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("Connectivity Error: errorCallback is not a function");
                return;
            }
            
    		var json = HybridLib.isConnected();
    		var obj = $.parseJSON(''+json);

    		if(obj.success != false)
    		{
    			successCallback(obj.value);
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		} 
		}
	};
}

if (typeof Contacts === "undefined") {
	Contacts = {
		getContacts : function(successCallback, errorCallback) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Contacts#getContacts because Library has expired...");
				return;
			}	
		
	   		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("Contacts Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("Contacts Error: errorCallback is not a function");
                return;
            }
			
			var contacts = new Array();
			var json = HybridLib.getAllContacts();
			var obj = $.parseJSON(''+json);
			
    		if(obj.success != true)
    		{		
    			if(typeof errorCallback == "function"){
        			errorCallback(obj.text);
    			}
    			return;
    		}			
			successCallback(obj);
		},
		getContactDetails : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Contacts#getContactDetails because Library has expired...");
				return;
			}	
			
	   		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("Contact Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("Contact Error: errorCallback is not a function");
                return;
            }
            
			if (!params.id) 
            {
                console.log("Contact Error: id is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Contact Error: id is undefined!");
                return;
            }
            
			var details = new Array();
			var json = HybridLib.getContact(params.id);
			var obj = $.parseJSON(""+json);
			
    		if(obj.success != true)
    		{		
    			if(typeof errorCallback == "function"){
        			errorCallback(obj.text);
    			}
    			return;
    		}

			successCallback(obj);
		},
		addContact : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Contacts#addContact because Library has expired...");
				return;
			}	
			
	   		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("Contact Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("Contact Error: errorCallback is not a function");
                return;
            }
            
            if (!params.firstName) 
            {
                console.log(" Error: firstName is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Contact Error: firstName is undefined!");
                return;
            }
            
			var i = 0;
			var json = "{";
			for ( var prop in params) {
				if (params.hasOwnProperty(prop)) {
					if (i > 0)
						json += ", ";
					json += "\"" + prop + "\":\"" + params[prop] + "\"";
					i++;
				}
			}
			json += "}";

    		var json = HybridLib.saveContact(json);
    		var obj = $.parseJSON(''+json);
 
    		if(obj.success == true)
    		{		
    			successCallback("Contact saved");
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
		},
		editContact : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Contacts#editContact because Library has expired...");
				return;
			}	
			
	   		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("Contact Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("Contact Error: errorCallback is not a function");
                return;
            }
            
			if (!params.id) 
            {
                console.log("Contact Error: id is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Contact Error: id is undefined!");
                return;
            }
			
			var i = 0;
			var json = "{";
			for ( var prop in params) {
				if (params.hasOwnProperty(prop)) {
					if (i > 0)
						json += ", ";
					json += "\"" + prop + "\":\"" + params[prop] + "\"";
					i++;
				}
			}
			json += "}";
			
    		var json = HybridLib.saveContact(json);
    		var obj = $.parseJSON(''+json);
 
    		if(obj.success == true)
    		{		
    			successCallback();
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
		},
		deleteContact : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Contacts#deleteContact because Library has expired...");
				return;
			}	
			
	   		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("Contact Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("Contact Error: errorCallback is not a function");
                return;
            }
            
			if (!params.id) 
            {
                console.log("Contact Error: id is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Contact Error: id is undefined!");
                return;
            }
            
    		var json = HybridLib.deleteContact(params.id);
    		var obj = $.parseJSON(''+json);
 
    		if(obj.success == true)
    		{		
    			successCallback();
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
		}
	};
};

if (typeof Database === "undefined") {
    Database = {
        getDatabases : function(successCallback, errorCallback) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#getDatabases because Library has expired...");
				return;
			}	
    	
            var json = HybridLib.getDatabases();
            if (json == null) {
                if (typeof errorCallback == "function") {
                    errorCallback();
                    return;
                }
            }
            
            if (typeof successCallback == "function") {
                successCallback($.parseJSON(''+json));
            }
        },
        createDatabase : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#createDatabase because Library has expired...");
				return;
			}	        	
        	
			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
        	
            var ret = HybridLib.createDatabase(params.dbname);
            if (ret) {
                if (typeof successCallback == "function") {
                    successCallback();
                }
            } else {
                if (typeof errorCallback == "function") {
                    errorCallback();
                    return;
                }
            }
        },
        getTables : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#getTables because Library has expired...");
				return;
			}	        	
        	
			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
        	
            var json = HybridLib.getTables(params.dbname);
            if (json == null) {
                if (typeof errorCallback == "function") {
                    errorCallback();
                    return;
                }
            }
            if (typeof successCallback == "function") {
                successCallback($.parseJSON(''+json));
            }
        },
        createTable : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#createTable because Library has expired...");
				return;
			}	
        	
			if (!params.columns) 
            {
                console.log("Database Error: columns is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: columns is undefined!");
                return;
            }
			
			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
			
			if (!params.tablename) 
            {
                console.log("Database Error: tablename is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: tablename is undefined!");
                return;
            }
        	
            var json = Database.createJsonData(params.columns);
            var ret = HybridLib.createTable(params.dbname, params.tablename, json);
            if (ret) {
                if (typeof successCallback == "function") {
                    successCallback();
                }
            } else {
                if (typeof errorCallback == "function") {
                    errorCallback();
                }
            }
        },
        dropTable : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#dropTable because Library has expired...");
				return;
			}	

			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
			
			if (!params.tablename) 
            {
                console.log("Database Error: tablename is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: tablename is undefined!");
                return;
            }
        	
            var ret = HybridLib.dropTable(params.dbname, params.tablename);
            if (ret) {
                if (typeof successCallback == "function") {
                    successCallback();
                }
            } else {
                if (typeof errorCallback == "function") {
                    errorCallback();
                }
            }
        },
        insertRecord : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#insertRecord because Library has expired...");
				return;
			}	

			if (!params.values) 
            {
                console.log("Database Error: values is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: values is undefined!");
                return;
            }
        	
			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
			
			if (!params.tablename) 
            {
                console.log("Database Error: tablename is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: tablename is undefined!");
                return;
            }
        	
            var json = Database.createJsonData(params.values);
            var result =  HybridLib.insertRecord(
                params.dbname,
                params.tablename,
                json);
            if (result == null || result == "-1") {
                if (typeof errorCallback == "function") {
                    errorCallback();
                    return;
                }
            } else {
                if (typeof successCallback == "function") {
                    successCallback(result);
                }
            }
        },
        updateRecord : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#updateRecord because Library has expired...");
				return;
			}	

			if (!params.values) 
            {
                console.log("Database Error: values is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: values is undefined!");
                return;
            }			
        	
			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
			
			if (!params.tablename) 
            {
                console.log("Database Error: tablename is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: tablename is undefined!");
                return;
            }        	
			
            var json = Database.createJsonData(params.values);
            var result =  HybridLib.updateRecord(
                params.dbname,
                params.tablename,
                json,
                params.where);

            if (result == null || result == "-1") {
                if (typeof errorCallback == "function") {
                    errorCallback();
                    return;
                }
            } else {
                if (typeof successCallback == "function") {
                    successCallback(result);
                }
            }
        },
        queryRecord : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#queryRecord because Library has expired...");
				return;
			}	
			
			if (!params.columns) 
            {
                console.log("Database Error: columns is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: columns is undefined!");
                return;
            }	
        	
			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
			
			if (!params.tablename) 
            {
                console.log("Database Error: tablename is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: tablename is undefined!");
                return;
            }  

            var json = HybridLib.queryRecord(
                params.dbname,
                params.tablename,
                params.columns,
                params.where,
                params.groupby,
                params.orderby);
            
            if (json == null || "undefined" == typeof json) {
                if (typeof errorCallback == "function") {
                    errorCallback();
                    return;
                }
            }
            
            //var result = new Array();
            var obj = $.parseJSON(''+json);
            /*for (var count = 0; count < obj.length; count++) {
                result[count] = new Array();

                var colCount = 0;
                for (var prop in obj[count]) {
                    result[count][colCount] = obj[count][prop];
                    colCount++;
                }
            }?*/

            if (typeof successCallback == "function") {
                //successCallback(result);
            	successCallback(obj);
            }
        },
        deleteRecord : function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#deleteRecord because Library has expired...");
				return;
			}	
			
			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
			
			if (!params.tablename) 
            {
                console.log("Database Error: tablename is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: tablename is undefined!");
                return;
            }
			
            var result = HybridLib.deleteRecord(
                params.dbname,
                params.tablename,
                params.where);
            
            if (result == null || result == "-1") {
                if (typeof errorCallback == "function") {
                    errorCallback();
                    return;
                }
            } else {
                if (typeof successCallback == "function") {
                    successCallback(result);
                }
            }
        },
        getColumnDetails: function(successCallback, errorCallback, params) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#getColumnDetails because Library has expired...");
				return;
			}	

			if (!params.dbname) 
            {
                console.log("Database Error: dbname is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: dbname is undefined!");
                return;
            }
			if (!params.tablename) 
            {
                console.log("Database Error: tablename is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("Database Error: tablename is undefined!");
                return;
            }
			
            var json = HybridLib.getColumns(
                params.dbname,
                params.tablename);

            var obj = $.parseJSON(''+json);
            
            if (json == null || "undefined" == typeof json) {
                if (typeof errorCallback == "function") {
                    errorCallback();
                    return;
                }
            } else {
                if (typeof successCallback == "function") {
                    successCallback(obj);
                }
            }        	
        },
        createJsonData : function(datas) {
			if ( isLibExpired == true ) {
				console.log("Cannot use Database#createJsonData because Library has expired...");
				return;
			}	

        	var itemCnt;
            var json = "[\n";
            for (var count = 0; count < datas.length; count++) {
                if (count > 0) {
                    json += ",";
                }
                json += "{\n";
                itemCnt = 0;
                for (var prop in datas[count]) {
                    if (datas[count].hasOwnProperty(prop)) {
                        if (itemCnt > 0) {
                            json += ",\n";
                        }
                        json += "\"" + prop + "\":\"" + datas[count][prop] + "\"";
                        itemCnt++;
                    }
                }
                json += "\n}\n";
            }
            json += "]\n";
            return json;
        }
    };
};

if(typeof DeviceInformation === "undefined"){
	DeviceInformation = {
		getDeviceInfo : function(successCallback, errorCallback, params){
			if ( isLibExpired == true ) {
				console.log("Cannot use DeviceInformation#getDeviceInfo because Library has expired...");
				return;
			}	

			// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("DeviceInfo Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("DeviceInfo Error: errorCallback is not a function");
                return;
            }			
			
    		var json = HybridLib.getDeviceInfo();
    		var obj = $.parseJSON(''+json);
 
    		if(obj.success == true)
    		{		
    			successCallback(obj);
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
		}		
	};
};

if (typeof Events === "undefined") {	
	Events = {};
	Events.callback = {};
	Events.registerCallback = function(successCallback) {
		if ( isLibExpired == true ) {
			console.log("Cannot use Events#registerCallback because Library has expired...");
			return;
		}	
	
	    if (typeof successCallback != "function") 
	    {
	        console.log("Events Error: successCallback is not a function");
	        return;
	    }
	    
	    Events.callback = successCallback;
	};
	Events.trigger = function(response) {
		if ( isLibExpired == true ) {
			console.log("Cannot use Events#trigger because Library has expired...");
			return;
		}	
		
		if(typeof Events.callback == "function")
			Events.callback(response);
	};
}

if (typeof Facebook === "undefined") {
	Facebook = {};
	Facebook.callbacks = {};
	Facebook.postStatus = function(successCallback, errorCallback, params){
		if ( isLibExpired == true ) {
			console.log("Cannot use Facebook#postStatus because Library has expired...");
			return;
		}	

		Facebook.callbacks = {};
		
        if (typeof successCallback != "function") 
        {
            console.log("Facebook Error: successCallback is not a function");
            return;
        }
        
        Facebook.callbacks.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Facebook Error: errorCallback is not a function");
            return;
        }

        if(errorCallback)
        	Facebook.callbacks.error = errorCallback;
        
        if (!params.message) 
        {
            console.log("Facebook Error: message is undefined!");
			if (errorCallback && (typeof errorCallback == "function")) 
				errorCallback("Facebook Error: message is undefined!");
            return;
        }
        
        HybridLib.postToFacebook(params.message);
	};

	Facebook.queryGraph = function(successCallback, errorCallback, params){
		if ( isLibExpired == true ) {
			console.log("Cannot use Facebook#queryGraph because Library has expired...");
			return;
		}	

		Facebook.callbacks = {};
		
        if (typeof successCallback != "function") 
        {
            console.log("Facebook Error: successCallback is not a function");
            return;
        }
        
        Facebook.callbacks.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Facebook Error: errorCallback is not a function");
            return;
        }

        if(errorCallback)
        	Facebook.callbacks.error = errorCallback;
        
        if (!params.path) 
        {
            console.log("Facebook Error: path is undefined!");
			if (errorCallback && (typeof errorCallback == "function")) 
				errorCallback("Facebook Error: path is undefined!");
            return;
        }		
        
        HybridLib.queryGraph(params.path);
	}
	
	Facebook.initialize = function(successCallback, errorCallback, params){
		if ( isLibExpired == true ) {
			console.log("Cannot use Facebook#initialize because Library has expired...");
			return;
		}	

		Facebook.callbacks = {};
		
        if (typeof successCallback != "function") 
        {
            console.log("Facebook Error: successCallback is not a function");
            return;
        }
        
        Facebook.callbacks.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Facebook Error: errorCallback is not a function");
            return;
        }

        if(errorCallback)
        	Facebook.callbacks.error = errorCallback;
        
        if (!params.app_id) 
        {
            console.log("Facebook Error: app_id is undefined!");
			if (errorCallback && (typeof errorCallback == "function")) 
				errorCallback("Facebook Error: app_id is undefined!");
            return;
        }		
        
        if (!params.permissions) 
        {
            console.log("Facebook Error: permissions is undefined!");
			if (errorCallback && (typeof errorCallback == "function")) 
				errorCallback("Facebook Error: permissions is undefined!");
            return;
        }
        
        var perm = "[";
        itemCnt = 0;
        
		$.each(params.permissions, function(ind, val) {
            if (itemCnt > 0) 
                perm += ", ";
            
            perm += "\""+val+"\"";
            itemCnt++;
		});
		
		perm += "]";
        HybridLib.initialize(params.app_id, perm);
	}
	
	Facebook.logout = function(successCallback, errorCallback, params){
		if ( isLibExpired == true ) {
			console.log("Cannot use Facebook#logout because Library has expired...");
			return;
		}	

		Facebook.callbacks = {};
		
        if (typeof successCallback != "function") 
        {
            console.log("Facebook Error: successCallback is not a function");
            return;
        }
        
        Facebook.callbacks.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Facebook Error: errorCallback is not a function");
            return;
        }

        if(errorCallback)
        	Facebook.callbacks.error = errorCallback;
        
        HybridLib.logout();
	}
	
	Facebook.onResults = function(response) {
		if ( isLibExpired == true ) {
			console.log("Cannot use Facebook#onResults because Library has expired...");
			return;
		}	
		
		var obj = $.parseJSON(''+response);
		if(obj.success == true)
		{
			switch(obj.response)
			{
			case 0 : 
				Facebook.callbacks.success();
				break;
			case 1 :
				var json = HybridLib.getFBJSON();
				var obj = $.parseJSON(''+json);
				Facebook.callbacks.success(obj);
				break;
			}
		} else if(typeof Facebook.callbacks.error == "function"){
			Facebook.callbacks.error(obj.text);
		} 
	};
}	

if (typeof FileAccess === "undefined") {
	FileAccess = {
    	listPathContents: function(successCallback, errorCallback, params) {
		
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#listPathContents because Library has expired...");
				return;
			}	
		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.filePath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
    		
    		var json = HybridLib.listContents(params.filePath);
    		var obj = $.parseJSON(''+json);
 
    		if(obj.success == true)
    		{		
    			successCallback(obj.files.replace(/'/g,'"'));
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
    	},
    	/*
    	 * readFile: Read file specified.
    	 * params.filePath: filepath of file.
    	 */
    	readFile: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#readFile because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.filePath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
    		
    		var json = HybridLib.readFile(params.filePath);
    		var obj = $.parseJSON(''+json);
    		
    		if(obj.success == true)
    		{
    			if(typeof successCallback == "function") {	
    				successCallback(obj.text);
    			}
    			
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
    	},
    	/*
    	 * writeToFile: write contents to file specified.
    	 * params.filePath: filepath of file.
    	 * params.fileContents: text to write to file.
    	 */
    	writeToFile: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#writeToFile because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.filePath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
            
            if (!params.fileContents) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file contents is undefined!");
                return;
            }
    		
    		var json = HybridLib.writeFile(params.filePath, params.fileContents);
    		var obj = $.parseJSON(''+json);
    		
    		if(obj.success == true)
    		{
    			successCallback(obj.success);    			
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
    	},
    	/*
    	 * deleteFile: delete file specified.
    	 * params.filePath: filepath of file.
    	 */
    	deleteFile: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#deleteFile because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.filePath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
            
            var json = HybridLib.deleteFile(params.filePath);
    		var obj = $.parseJSON(''+json);

    		if(obj.success == true)
    		{
    			successCallback(obj.success);    			
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}	
    	},
    	/*
    	 * copyFile: copy specify file to specified destination.
    	 * params.fromPath: file path of source file.
    	 * params.toPath: file path of destination file.
    	 */
    	copyFile: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#copyFile because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.fromPath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
            
            if (!params.toPath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file contents is undefined!");
                return;
            }
    		
    		var json = HybridLib.copyFile(params.fromPath, params.toPath);
    		var obj = $.parseJSON(''+json);
    		
    		if(obj.success == true)
    		{
    			successCallback(obj.success);		
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}   		
    	},
    	/*
    	 * copyFile: move specify file to specified destination.
    	 * params.fromPath: file path of source file.
    	 * params.toPath: file path of destination file.
    	 */
    	moveFile: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#moveFile because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.fromPath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
            
            if (!params.toPath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file contents is undefined!");
                return;
            }

    		var json = HybridLib.moveFile(params.fromPath, params.toPath);
    		var obj = $.parseJSON(''+json);
    		
    		if(obj.success == true)
    		{	
    			successCallback(obj.success);		
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}   
    	},
    	/*
    	 * fileExists: Check if file specified exists.
    	 * params.filePath: filepath to check.
    	 */
    	fileExists: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#fileExists because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.filePath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
            
            var json = HybridLib.isFileExist(params.filePath);
    		var obj = $.parseJSON(''+json);

    		if(obj.success == false)
    		{
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: "+obj.text);
    			return;
    		}
    		
    		successCallback(obj.value);
    	},
    	/*
    	 * isDirectory: Check if file specified is a directory.
    	 * params.filePath: filepath to check.
    	 */
    	isDirectory: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#isDirectory because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.filePath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
            
            var json = HybridLib.isDirectory(params.filePath);
    		var obj = $.parseJSON(''+json);

    		if(obj.success == false)
    		{
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: "+obj.text);
    			return;
    		}
    		
    		successCallback(obj.value);
    	},
    	createDirectory: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#createDirectory because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.filePath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
    		
    		var json = HybridLib.createDirectory(params.filePath);
    		var obj = $.parseJSON(''+json);
    		
    		if(obj.success == true)
    		{
    			if(typeof successCallback == "function") {	
    				successCallback(obj.success);
    			}
    			
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
    	},
    	getImage: function(successCallback, errorCallback, params)
    	{
			if ( isLibExpired == true ) {
				console.log("Cannot use FileAccess#getImage because Library has expired...");
				return;
			}	
    		
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("FileAccess Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("FileAccess Error: errorCallback is not a function");
                return;
            }
            
            if (!params.fromPath) 
            {
                console.log("FileAccess Error: file is undefined!");
    			if (errorCallback && (typeof errorCallback == "function")) 
    				errorCallback("FileAccess Error: file is undefined!");
                return;
            }
    		
    		var json = HybridLib.getImageFromPath(params.fromPath);
    		var obj = $.parseJSON(''+json);
    		
    		if(obj.success == true)
    		{
    			if(typeof successCallback == "function") {	
    				successCallback(obj.image);
    			}
    			
    		} else if(typeof errorCallback == "function"){
    			errorCallback(obj.text);
    		}
    	}
	};
	
	
}

if (typeof Geolocation === "undefined") {
	Geolocation = {	
		isGeoRunning : false,
		startUpdatingLocation : function() {
			if ( isLibExpired == true ) {
				console.log("Cannot use Geolocation#startUpdatingLocation because Library has expired...");
				return;
			}	
		
			if (!this.isGeoRunning) {
				HybridLib.startGeolocation();
				this.isGeoRunning = true;
			}
		},
		stopUpdatingLocation : function() {
			if ( isLibExpired == true ) {
				console.log("Cannot use Geolocation#stopUpdatingLocation because Library has expired...");
				return;
			}	
			
			if (this.isGeoRunning) {
				HybridLib.stopGeolocation();
				this.isGeoRunning = false;
			}
		},
		getLatitude : function() {
			if ( isLibExpired == true ) {
				console.log("Cannot use Geolocation#getLatitude because Library has expired...");
				return;
			}	
			
			var latitude = HybridLib.getLatitude();
			if ("" != latitude && "Provider not available." != latitude) {
				return latitude;
			}
			return null;
		},
		getLongitude : function() {
			if ( isLibExpired == true ) {
				console.log("Cannot use Geolocation#getLongitude because Library has expired...");
				return;
			}	
			
			var longitude = HybridLib.getLongitude();
			if ("" != longitude && "Provider not available." != longitude) {
				return longitude;
			}
			return null;
		}
	}
};

if(typeof MediaPlayer === "undefined"){
	MediaPlayer = {
		selectAudio : function(){
			if ( isLibExpired == true ) {
				console.log("Cannot use MediaPlayer#selectAudio because Library has expired...");
				return;
			}	

			HybridLib.openFileBrowser();			
		},
		playAudio : function(successCallback, errorCallback){
			if ( isLibExpired == true ) {
				console.log("Cannot use MediaPlayer#playAudio because Library has expired...");
				return;
			}	
			
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("MediaPlayer Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("MediaPlayer Error: errorCallback is not a function");
                return;
            }
            
			var bIsPlaying = HybridLib.playAudio();
			
			if (bIsPlaying != "undefined") {
				successCallback(bIsPlaying);
			} else if (errorCallback && (typeof errorCallback != "function")) {
				errorCallback();
			}
		},
		pauseAudio : function(successCallback, errorCallback){
			if ( isLibExpired == true ) {
				console.log("Cannot use MediaPlayer#pauseAudio because Library has expired...");
				return;
			}	
			
    		// successCallback required
            if (typeof successCallback != "function") 
            {
                console.log("MediaPlayer Error: successCallback is not a function");
                return;
            }
            
            // errorCallback optional
            if (errorCallback && (typeof errorCallback != "function")) 
            {
                console.log("MediaPlayer Error: errorCallback is not a function");
                return;
            }
            
			var bIsPlaying = HybridLib.pauseAudio();
			
			if (bIsPlaying != "undefined") {
				successCallback(bIsPlaying);
			} else if (errorCallback && (typeof errorCallback != "function")) {
				errorCallback();
			}
		}
	};
};

if (typeof Twitter === "undefined") {
	Twitter = {};
	Twitter.callback = {};
	Twitter.processing = false;
	Twitter.postTweet = function(successCallback, errorCallback, params)
	{
		if ( isLibExpired == true ) {
			console.log("Cannot use Twitter#postTweet because Library has expired...");
			return;
		}	
		
		if(Twitter.processing)
		{
			if (errorCallback && (typeof errorCallback != "function")) 
				errorCallback();
			return;
		}
			
		Twitter.callback = {};
		// successCallback required
        if (typeof successCallback != "function") 
        {
            console.log("Twitter Error: successCallback is not a function");
            return;
        }
        
        Twitter.callback.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Twitter Error: errorCallback is not a function");
            return;
        }
        
        if(errorCallback)
        	Twitter.callback.error = errorCallback;
        
        if (!params.tweet) 
        {
            console.log("Twitter Error: tweet is undefined!");
			if (errorCallback && (typeof errorCallback == "function")) 
				errorCallback("Twitter Error: tweet is undefined!");
            return;
        }
        
        Twitter.processing = true;
		HybridLib.postTweet(params.tweet);
	};
	Twitter.deleteTweet = function(successCallback, errorCallback, params)
	{
		if ( isLibExpired == true ) {
			console.log("Cannot use Twitter#deleteTweet because Library has expired...");
			return;
		}	
		
		if(Twitter.processing)
		{
			if (errorCallback && (typeof errorCallback != "function")) 
				errorCallback();
			return;
		}
		
		Twitter.callback = {};
		// successCallback required
        if (typeof successCallback != "function") 
        {
            console.log("Twitter Error: successCallback is not a function");
            return;
        }
        
        Twitter.callback.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Twitter Error: errorCallback is not a function");
            return;
        }
        
        if(errorCallback)
        	Twitter.callback.error = errorCallback;

        if (!params.tweetId) 
        {
            console.log("Twitter Error: tweetId is undefined!");
			if (errorCallback && (typeof errorCallback == "function")) 
				errorCallback("Twitter Error: tweetId is undefined!");
            return;
        }
        
        Twitter.processing = true;
		HybridLib.deleteTweet(params.tweetId);	
	};
	Twitter.getHomeTimeline = function(successCallback, errorCallback, params)
	{
		if ( isLibExpired == true ) {
			console.log("Cannot use Twitter#getHomeTimeline because Library has expired...");
			return;
		}	
		
		if(Twitter.processing)
		{
			if (errorCallback && (typeof errorCallback != "function")) 
				errorCallback();
			return;
		}
		
		Twitter.callback = {};
		// successCallback required
        if (typeof successCallback != "function") 
        {
            console.log("Twitter Error: successCallback is not a function");
            return;
        }
        
        Twitter.callback.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Twitter Error: errorCallback is not a function");
            return;
        }
        
        if(errorCallback)
        	Twitter.callback.error = errorCallback;
        
        Twitter.processing = true;
		HybridLib.getHomeTimeline();	
	};
	Twitter.getUserTimeline = function(successCallback, errorCallback, params)
	{
		if ( isLibExpired == true ) {
			console.log("Cannot use Twitter#getUserTimeline because Library has expired...");
			return;
		}	
		
		if(Twitter.processing)
		{
			if (errorCallback && (typeof errorCallback != "function")) 
				errorCallback();
			return;
		}
		
		Twitter.callback = {};
		// successCallback required
        if (typeof successCallback != "function") 
        {
            console.log("Twitter Error: successCallback is not a function");
            return;
        }
        
        Twitter.callback.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Twitter Error: errorCallback is not a function");
            return;
        }
        
        if(errorCallback)
        	Twitter.callback.error = errorCallback;
        
        Twitter.processing = true;
		HybridLib.getUserTimeline();
	},
	Twitter.getPublicTimeline = function(successCallback, errorCallback, params)
	{
		if ( isLibExpired == true ) {
			console.log("Cannot use Twitter#getPublicTimeline because Library has expired...");
			return;
		}	
		
		if(Twitter.processing)
		{
			if (errorCallback && (typeof errorCallback != "function")) 
				errorCallback();
			return;
		}
		
		Twitter.callback = {};
		// successCallback required
        if (typeof successCallback != "function") 
        {
            console.log("Twitter Error: successCallback is not a function");
            return;
        }
        
        Twitter.callback.success = successCallback;
        
        // errorCallback optional
        if (errorCallback && (typeof errorCallback != "function")) 
        {
            console.log("Twitter Error: errorCallback is not a function");
            return;
        }
        
        if(errorCallback)
        	Twitter.callback.error = errorCallback;
        
        Twitter.processing = true;
		HybridLib.getPublicTimeline();		
	};
	Twitter.response = function(json)
	{
		if ( isLibExpired == true ) {
			console.log("Cannot use Twitter#response because Library has expired...");
			return;
		}	
		
		var obj = $.parseJSON(''+json);
		if(obj.success)
		{
			switch(obj.mode)
			{
				case 1:
					var json = HybridLib.getStrTimeline();
					var obj = $.parseJSON(''+json);
					Twitter.processing = false;
					Twitter.callback.success(obj);
					break;
				case 2:
				case 3:
					Twitter.processing = false;
					Twitter.callback.success(true);
					break;
			}
		} else if(typeof Twitter.callback.error == "function"){
			Twitter.processing = false;
			Twitter.callback.error(obj.text);
		} 		
	};
};